var gulp = require('gulp');

var playersPath = {
  chrome: 'chrome/app/player',
  firefox: 'firefox/data/player',
  safari: 'safari.safariextension/app/player'
};

var webglFiles = [
  'connect.js',
  'load.js',
  'verify-compatibility.js',
  'error.js',
  'window.html',
  'TemplateData/*',
  'Release/*'
];

var webplayerFiles = [
  'window.html',
  'verify-compatibility.js',
  'webplayer.js',
  'webplayer.unity3d',
  'UnityObject2.js',
  '../vendors/jquery.js'
];

var playerFiles = [
  'TemplateData/*',
  'js/*',
  'vendors/qdclient/qdclient.js'
];

var webglTask = function(dest) {
  gulp.src(webglFiles, {base: 'player/webgl', cwd: 'player/webgl'})
    .pipe(gulp.dest(dest));

  playerTask(dest);
};

var webplayerTask = function(dest) {
  gulp.src(webplayerFiles, {base: 'player/webplayer', cwd: 'player/webplayer'})
    .pipe(gulp.dest(dest));

  playerTask(dest);

  // Additional dependencies
  gulp.src(['vendors/jquery/dist/jquery.min.js'], {base: 'player', cwd: 'player'})
    .pipe(gulp.dest(dest));
};

var playerTask = function(dest) {
  gulp.src(playerFiles, {base: 'player', cwd: 'player'})
    .pipe(gulp.dest(dest));
};

gulp.task('chrome', function() {
  webglTask(playersPath.chrome);
});

gulp.task('firefox', function() {
  webglTask(playersPath.firefox);
});

gulp.task('safari', function() {
  webplayerTask(playersPath.safari);
});